libzypp: zyppng::UserRequest Class Reference

libzypp 17.38.6

zyppng::UserRequest Class Referenceabstract

`#include <zypp-core/ng/ui/userrequest.h>`

Inheritance diagram for zyppng::UserRequest:

## Public Member Functions
| UserRequest (UserData userData={})
| ~UserRequest () override
virtual UserRequestType | type () const =0
const UserData & | userData () const
UserData & | userData ()
Public Member Functions inherited from zyppng::Base
| Base ()
virtual | ~Base ()
WeakPtr | parent () const
void | addChild (const Base::Ptr &child)
void | removeChild (const Ptr &child)
const std::unordered_set< Ptr > & | children () const
std::thread::id | threadId () const
template<typename T>
std::vector< std::weak_ptr< T > > | findChildren () const
template<typename T>
std::shared_ptr< T > | shared_this () const
template<typename T>
std::shared_ptr< T > | shared_this ()
template<typename T>
std::weak_ptr< T > | weak_this () const
template<typename T>
std::weak_ptr< T > | weak_this ()
template<typename SenderFunc, typename ReceiverFunc>
auto | connect (SenderFunc &&sFun, typename internal::MemberFunction< ReceiverFunc >::ClassType &recv, ReceiverFunc &&rFunc)
template<typename SenderFunc, typename ReceiverFunc, typename ... Tracker>
std::enable_if_t< std::is_member_function_pointer_v< SenderFunc >, connection > | connectFunc (SenderFunc &&sFun, ReceiverFunc &&rFunc, const Tracker &...trackers)
void | setData (uint32_t quark, zypp::AutoDispose< void * > data)
void * | data (uint32_t quark)
void | clearData (uint32_t quark)

## Private Attributes
UserData | _userData

## Additional Inherited Members
Public Types inherited from zyppng::Base
using | Ptr = std::shared_ptr<Base>
using | WeakPtr = std::weak_ptr<Base>
Static Public Member Functions inherited from zyppng::Base
template<typename Obj, typename Functor>
static decltype(auto) | make_base_slot (Obj *o, Functor &&f)
template<typename SenderFunc, typename ReceiverFunc>
static auto | connect (typename internal::MemberFunction< SenderFunc >::ClassType &s, SenderFunc &&sFun, typename internal::MemberFunction< ReceiverFunc >::ClassType &recv, ReceiverFunc &&rFunc)
template<typename SenderFunc, typename ReceiverFunc, typename ... Tracker>
static auto | connectFunc (typename internal::MemberFunction< SenderFunc >::ClassType &s, SenderFunc &&sFun, ReceiverFunc &&rFunc, const Tracker &...trackers)
Protected Member Functions inherited from zyppng::Base
| Base (BasePrivate &dd)
Protected Attributes inherited from zyppng::Base
std::unique_ptr< BasePrivate > | d_ptr

## Detailed Description

The UserRequest class provides a base object to send UI requests to the user, every time libzypp needs input from the User, a UserRequest is generated and sent via the UserInterface to the user code, which can decide how to render the request, a CLI app would render a prompt, while a UI application likely would open a popup window.

Definition at line 48 of file userrequest.h.

## Constructor & Destructor Documentation

## ◆ UserRequest()

zyppng::UserRequest::UserRequest | ( | UserData | userData = {} | ) |

Definition at line 15 of file userrequest.cc.

## ◆ ~UserRequest()

zyppng::UserRequest::~UserRequest | ( |  | ) |
| override

Definition at line 19 of file userrequest.cc.

## Member Function Documentation

## ◆ type()

virtual UserRequestType zyppng::UserRequest::type | ( |  | ) | const
| pure virtual

Implemented in zyppng::BooleanChoiceRequest, zyppng::ListChoiceRequest, zyppng::ShowMessageRequest, and zyppng::TrustKeyRequest.

## ◆ userData() [1/2]

const UserData & zyppng::UserRequest::userData | ( |  | ) | const

Definition at line 22 of file userrequest.cc.

## ◆ userData() [2/2]

UserData & zyppng::UserRequest::userData | ( |  | ) |

Definition at line 27 of file userrequest.cc.

## Member Data Documentation

## ◆ _userData

UserData zyppng::UserRequest::_userData
| private

Definition at line 58 of file userrequest.h.

The documentation for this class was generated from the following files:

- zypp-core/ng/ui/userrequest.h
- zypp-core/ng/ui/userrequest.cc